#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE !FALSE
#endif

static void
gen_randoms(int bdays[], int items)
{
	int i;
	for(i=0;i<items;i++)
		bdays[i] = 1 + (int)(365.0*rand()/(RAND_MAX+1.0));
}

static int
same_at_least(int bdays[], int items, int min_same)
{
	int i,j;
	for(i=0;i<items;i++) {
		int same = 1;
		for(j=i+1;j<items;j++) {
			if(bdays[i]==bdays[j])
				same++;
			if(same>=min_same)
				return TRUE;
		}
	}
	return FALSE;
}

int
main(void)
{
	int persons;
	int min_same;
	int *bdays;
	double result;
	int total = 0;
	int yes = 0;
	int tries;

	printf("\nEnter the number of people in the room: ");
	scanf("%d",&persons);
	printf("\nAt least how many people should have the same birthday?: ");
	scanf("%d",&min_same);
	printf("\nHow many tests should I do?: ");
	scanf("%d",&tries);

	puts("");

	srand(time(NULL)*getpid());

	bdays = malloc(persons*sizeof(int));

	do {
		gen_randoms(bdays,persons);

		if(same_at_least(bdays,persons,min_same))
			yes++;
		total++;
	} while(total<tries);

	result = ((double)yes)/total;

	printf("By random testing of %d rooms of %d people, we found %d\n"
	       "to have at least %d people that have the same birthdate.\n"
	       "The probability appears to be %f\n\n",
	       total,persons,yes,min_same,result);

	return 0;
}
